"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createDatabase = exports.SyncDatabase = exports.Database = exports.DatabaseObject = exports.DatabaseArray = exports.getNormalValue = exports.createDatabaseValue = void 0;
function createDatabaseValue(val) {
    if (val instanceof DatabaseObject || val instanceof DatabaseArray)
        return val;
    if (val instanceof Array)
        return new DatabaseArray(val);
    if (val instanceof Object)
        return new DatabaseObject(val);
    return val;
}
exports.createDatabaseValue = createDatabaseValue;
function getNormalValue(val) {
    if (val == {})
        return {};
    else if (val instanceof DatabaseObject || val instanceof DatabaseArray)
        return getNormalValue(val.data);
    else if (Array.isArray(val)) {
        for (var i = 0; i < val.length; i++) {
            val[i] = getNormalValue(val[i]);
        }
    }
    else if (typeof val === "object" && val !== null) {
        Object.keys(val).forEach(function (k) { return val[k] = getNormalValue(val[k]); });
    }
    return val;
}
exports.getNormalValue = getNormalValue;
var DatabaseArray = (function () {
    function DatabaseArray(data) {
        if (data === void 0) { data = []; }
        this.data = data;
    }
    Object.defineProperty(DatabaseArray.prototype, "data", {
        get: function () {
            return this._data;
        },
        set: function (data) {
            this._data = getNormalValue(data);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatabaseArray.prototype, "length", {
        get: function () {
            return this._data.length;
        },
        enumerable: false,
        configurable: true
    });
    DatabaseArray.prototype.set = function (key, value) {
        if (typeof key == "string")
            this.set(key.split(/[.\[\]]/g), value);
        else if (typeof key == "number")
            this._data[key] = getNormalValue(value);
        else {
            if (key.length > 1) {
                console.log("a");
                if (this._data[key[0]] == null)
                    this._data[key[0]] = createObjectForKey(key);
                var e = createDatabaseValue(this._data[key[0]]);
                if (!(e instanceof DatabaseObject || e instanceof DatabaseArray))
                    throw new Error("Can't use set property of " + typeof e);
                e.set(key.slice(1, key.length), value);
            }
            else {
                console.log("before", this._data);
                if (typeof key[0] === 'string')
                    this.set(parseInt(key[0]), value);
                else
                    this.set(key[0], value);
                console.log("after: ", this._data);
            }
        }
        return this;
    };
    DatabaseArray.prototype.setDefault = function (key, value) {
        if (!this.contains(key))
            this.set(key, value);
        return this;
    };
    DatabaseArray.prototype.get = function (key) {
        return createDatabaseValue(this.getNormal(key));
    };
    DatabaseArray.prototype.getNormal = function (key) {
        if (typeof key == "string")
            return this.getNormal(key.split(/[.\[\]]/g));
        else if (typeof key == "number")
            return this._data[key];
        else {
            if (key.length > 1) {
                var e = createDatabaseValue(this._data[key[0]]);
                if (!(e instanceof DatabaseObject || e instanceof DatabaseArray))
                    return undefined;
                return e === null || e === void 0 ? void 0 : e.getNormal(key.slice(1, key.length));
            }
            else {
                return this._data[typeof key[0] == "string" ? parseInt(key[0]) : key[0]];
            }
        }
    };
    DatabaseArray.prototype.update = function (key, update) {
        this.set(key, update(this.get(key)));
        return this;
    };
    DatabaseArray.prototype.contains = function (key) {
        if (typeof key == "string")
            return this.contains(key.split(/[.\[\]]/g));
        else if (typeof key == "number")
            return this.data[key] != undefined;
        else {
            if (key.length > 1) {
                var e = createDatabaseValue(this.data[key[0]]);
                if (!(e instanceof DatabaseObject || e instanceof DatabaseArray))
                    return false;
                return e === null || e === void 0 ? void 0 : e.contains(key.slice(1, key.length));
            }
            else {
                return (this.data[typeof key[0] == "string" ? parseInt(key[0]) : key[0]]) != undefined;
            }
        }
    };
    DatabaseArray.prototype.push = function () {
        var _a;
        var values = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            values[_i] = arguments[_i];
        }
        (_a = this._data).push.apply(_a, values.map(function (v) { return getNormalValue(v); }));
        return this;
    };
    return DatabaseArray;
}());
exports.DatabaseArray = DatabaseArray;
var DatabaseObject = (function () {
    function DatabaseObject(data) {
        if (data === void 0) { data = {}; }
        this._data = data;
    }
    Object.defineProperty(DatabaseObject.prototype, "data", {
        get: function () {
            return this._data;
        },
        set: function (data) {
            this._data = getNormalValue(data);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DatabaseObject.prototype, "length", {
        get: function () {
            return Object.keys(this._data).length;
        },
        enumerable: false,
        configurable: true
    });
    DatabaseObject.prototype.set = function (key, value) {
        if (typeof key == "string")
            return this.set(key.split(/[.\[\]]/g), value);
        else {
            if (key.length > 1) {
                if (this._data[key[0]] == null)
                    this._data[key[0]] = createObjectForKey(key);
                var e = createDatabaseValue(this._data[key[0]]);
                if (!(e instanceof DatabaseObject || e instanceof DatabaseArray))
                    throw new Error("Can't use set property of " + typeof e);
                e.set(key.slice(1, key.length), value);
            }
            else {
                this._data[key[0]] = getNormalValue(value);
            }
        }
        return this;
    };
    DatabaseObject.prototype.setDefault = function (key, value) {
        if (!this.contains(key))
            this.set(key, value);
        return this;
    };
    DatabaseObject.prototype.setDefaults = function (defaults) {
        var _this = this;
        Object.keys(defaults).forEach(function (k) {
            if (_this._data[k] === null || _this._data[k] === undefined)
                _this._data[k] = getNormalValue(defaults[k]);
            else if (defaults[k] instanceof Object && _this._data[k] instanceof Object)
                createDatabaseValue(_this._data[k]).setDefaults(defaults[k]);
        });
        return this;
    };
    DatabaseObject.prototype.get = function (key) {
        return createDatabaseValue(this.getNormal(key));
    };
    DatabaseObject.prototype.getNormal = function (key) {
        if (typeof key == "string")
            return this.getNormal(key.split(/[.\[\]]/g));
        else {
            if (key.length > 1) {
                var e = createDatabaseValue(this._data[key[0]]);
                if (!(e instanceof DatabaseObject || e instanceof DatabaseArray))
                    return undefined;
                return e === null || e === void 0 ? void 0 : e.getNormal(key.slice(1, key.length));
            }
            else {
                return this._data[key[0]];
            }
        }
    };
    DatabaseObject.prototype.update = function (key, update) {
        this.set(key, update(this.get(key)));
        return this;
    };
    DatabaseObject.prototype.contains = function (key) {
        if (typeof key == "string")
            return this.contains(key.split(/[.\[\]]/g));
        else {
            if (key.length > 1) {
                var e = createDatabaseValue(this._data[key[0]]);
                if (!(e instanceof DatabaseObject || e instanceof DatabaseArray))
                    return false;
                return e === null || e === void 0 ? void 0 : e.contains(key.slice(1, key.length));
            }
            else {
                return this._data[key[0]] != undefined;
            }
        }
    };
    DatabaseObject.prototype.generateId = function (name) {
        var counter = "id_counters." + name;
        if (this.get(counter) == null)
            this.set(counter, -1);
        return this.update(counter, function (e) { return e + 1; }).get(counter);
    };
    return DatabaseObject;
}());
exports.DatabaseObject = DatabaseObject;
var Database = (function (_super) {
    __extends(Database, _super);
    function Database(adapter, data) {
        var _this = _super.call(this, data) || this;
        _this.adapter = adapter;
        _this.adapter = adapter;
        return _this;
    }
    Database.prototype.saveData = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.adapter.save(this.data)];
                    case 1:
                        _a.sent();
                        return [2, this];
                }
            });
        });
    };
    Database.prototype.reloadData = function () {
        return __awaiter(this, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = this;
                    return [4, this.adapter.load()];
                case 1:
                    _a.data = _b.sent();
                    return [2, this];
            }
        }); });
    };
    return Database;
}(DatabaseObject));
exports.Database = Database;
var SyncDatabase = (function (_super) {
    __extends(SyncDatabase, _super);
    function SyncDatabase(adapter, data) {
        var _this = _super.call(this, data || adapter.load()) || this;
        _this.adapter = adapter;
        _this.adapter = adapter;
        return _this;
    }
    SyncDatabase.prototype.saveData = function () { this.adapter.save(this.data); return this; };
    SyncDatabase.prototype.reloadData = function () { this.data = this.adapter.load(); return this; };
    return SyncDatabase;
}(DatabaseObject));
exports.SyncDatabase = SyncDatabase;
function createDatabase(adapter) {
    var result = adapter.load();
    if (result instanceof Promise) {
        return new Promise(function (rs) {
            result.then(function (data) {
                rs(new Database(adapter, data));
            });
        });
    }
    return new SyncDatabase(adapter, result);
}
exports.createDatabase = createDatabase;
function createObjectForKey(key) {
    if (typeof key == "string")
        return createObjectForKey(key.split(/[.\[\]]/g));
    if (typeof key[1] == 'number' || (typeof key[1] == 'string' && isNumberString(key[1])))
        return [];
    return {};
}
var numberCharacters = "0123456789";
function isNumberString(s) {
    for (var i = 0; i < s.length; i++)
        if (!numberCharacters.includes(s.charAt(i)))
            return false;
    return true;
}
;
